=== assembler/ext/src/getopt_pp/CMakeLists.txt ===
project(getopt_pp CXX)

add_library(getopt_pp STATIC
            getopt_pp.cpp)
