=== debian/changelog ===
spades (3.15.5+dfsg-7) unstable; urgency=medium

  * Replace distutils which is removed in Python3.12
    Closes: #1061846
  * Build-Depends: s/dh-python/dh-sequence-python3/ (routine-update)
  * Depends: s/python3-distutils/python3-packaging/

 -- Andreas Tille <tille@debian.org>  Fri, 02 Feb 2024 09:16:42 +0100

spades (3.15.5+dfsg-6) unstable; urgency=medium

  * d/rules: disable lto builds.
    Upstream is aware that there is a problem with lto appllied on spades,
    and this seems to be caused by a lingering compiler bug. (Closes: #1015668)

 -- Étienne Mollier <emollier@debian.org>  Sun, 03 Dec 2023 14:52:02 +0100

spades (3.15.5+dfsg-5) unstable; urgency=medium

  [ Heinrich Schuchardt ]
  * Add missing libzstd-dev build dependency
    Closes: #1052315 (LP: #2036726)

  [ Andreas Tille ]
  * Standards-Version: 4.6.2 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 21 Sep 2023 13:22:20 +0200

spades (3.15.5+dfsg-4) unstable; urgency=medium

  * d/control: spades is AMD64 only, as per upstream. Closes: #976523
  * d/patches: mark many as not needing forwarding

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 09 Aug 2023 12:45:25 +0200

spades (3.15.5+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Add fix-gcc13.patch to fix gcc-13 build issues. (Closes: #1037863)

 -- Bo YU <tsu.yubo@gmail.com>  Thu, 20 Jul 2023 21:38:50 +0800

spades (3.15.5+dfsg-2) unstable; urgency=medium

  * d/control: add missing build-deps following llvm reorganization.
    (Closes: #1022309)
  * yaml_load.patch: update to fix new pyyaml.load calls. (Closes: #1022086)
  * d/copyright: bump copyright year.

 -- Étienne Mollier <emollier@debian.org>  Sun, 23 Oct 2022 16:59:13 +0200

spades (3.15.5+dfsg-1) unstable; urgency=medium

  * New upstream version 3.15.5+dfsg
  * d/patches/:
    + fix-privacy-breaches.patch: update badges list.
    + python3.patch: refresh.
    + 0003_accept-system-bwa.patch: unfuzz.
    + yaml_load.patch: unfuzz.
  * d/m/coronaspades.1.adoc: add manual page for coronaspades.
  * d/links: create a link for coronaspades.py manual.
  * d/t/run-upstreams-tests: add self tests for plasmidspades and coronaspades.
    Also, the truspades command is deprecated, so don't make it's self-test
    failure critical.
  * d/salsa-ci.yml: disable run for i386 architecture.
  * d/NEWS: forward deprecation of truspades with notice it may not work well.

 -- Étienne Mollier <emollier@debian.org>  Mon, 01 Aug 2022 21:11:59 +0200

spades (3.15.4+dfsg-3) unstable; urgency=medium

  * d/t/run-upstreams-tests: make tests a bit more verbose.
  * Adjust 0003_accept-system-bwa.patch: import support functions.
    (Closes: #1011968)
  * Refresh yaml_load.patch.
  * Remove patches not part of d/p/series anymore.
  * Add fix-privacy-breaches.patch: remove build status badges.
  * Add typos.patch: fix typos caught by lintian.
  * d/copyright: reorder to match globbing properly.
  * d/s/lintian-overrides: unclear why html files are missing source code.
  * Standards-Version: 4.6.1 (routine-update)

 -- Étienne Mollier <emollier@debian.org>  Sat, 25 Jun 2022 17:41:51 +0200
