## spades 4.0.0%2Breally3.15.5%2Bdfsg

=== assembler/src/projects/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

add_subdirectory(spades)
add_subdirectory(hammer)
add_subdirectory(ionhammer)
add_subdirectory(corrector)
add_subdirectory(scaffold_correction)
add_subdirectory(kmercount)
add_subdirectory(bin_converter)
add_subdirectory(gbuilder)
add_subdirectory(gmapper)
add_subdirectory(unitig_coverage)
add_subdirectory(spaligner)
add_subdirectory(gsimplifier)
add_subdirectory(cds_subgraphs)
add_subdirectory(bin_analysis)
